Package ghidra.app.util.bin.format.dwarf.attribs

# Record Class DWARFFormContext

java.lang.Object
java.lang.Record
ghidra.app.util.bin.format.dwarf.attribs.DWARFFormContext

Record Components:
  `reader` - `BinaryReader`
  `compUnit` - `DWARFCompilationUnit`
  `def` - `DWARFAttributeDef`
  `dwarfIntSize` - size of dwarf serialization ints, either 4 (32 bit dwarf) or 8 (64 bit dwarf). Can be different from compUnit's intSize if this context is being used to read values from a non-".debuginfo" section that has unit headers that specify an independent intSize.

public record DWARFFormContext(BinaryReader reader, DWARFCompilationUnit compUnit, DWARFAttributeDef<?> def, int dwarfIntSize) extends Record
Context given to the `DWARFForm.readValue(DWARFFormContext)` method to enable it to create `DWARFAttributeValue`s.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DWARFFormContext(BinaryReader reader, DWARFCompilationUnit compUnit, DWARFAttributeDef<?> def)`
  Creates a new DWARFFormContext, using the compUnit's int size
  `DWARFFormContext(BinaryReader reader, DWARFCompilationUnit compUnit, DWARFAttributeDef<?> def, int dwarfIntSize)`
  Creates an instance of a `DWARFFormContext` record class.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `DWARFCompilationUnit`
  `compUnit()`
  Returns the value of the `compUnit` record component.
  `DWARFAttributeDef<?>`
  `def()`
  Returns the value of the `def` record component.
  `int`
  `dwarfIntSize()`
  Returns the value of the `dwarfIntSize` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `BinaryReader`
  `reader()`
  Returns the value of the `reader` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DWARFFormContext

    public DWARFFormContext(BinaryReader reader, DWARFCompilationUnit compUnit, DWARFAttributeDef<?> def)
    Creates a new DWARFFormContext, using the compUnit's int size
    Parameters:
      `reader` - stream that will be used to read the dwarf form value
      `compUnit` - `DWARFCompilationUnit` that contains the value
      `def` - identity info about the attribute being read

  - ### DWARFFormContext

    public DWARFFormContext(BinaryReader reader, DWARFCompilationUnit compUnit, DWARFAttributeDef<?> def, int dwarfIntSize)
    Creates an instance of a `DWARFFormContext` record class.
    Parameters:
      `reader` - the value for the `reader` record component
      `compUnit` - the value for the `compUnit` record component
      `def` - the value for the `def` record component
      `dwarfIntSize` - the value for the `dwarfIntSize` record component

- ## Method Details

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. Reference components are compared with `Objects::equals(Object,Object)`; primitive components are compared with '=='.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### reader

    public BinaryReader reader()
    Returns the value of the `reader` record component.
    Returns:
      the value of the `reader` record component

  - ### compUnit

    public DWARFCompilationUnit compUnit()
    Returns the value of the `compUnit` record component.
    Returns:
      the value of the `compUnit` record component

  - ### def

    public DWARFAttributeDef<?> def()
    Returns the value of the `def` record component.
    Returns:
      the value of the `def` record component

  - ### dwarfIntSize

    public int dwarfIntSize()
    Returns the value of the `dwarfIntSize` record component.
    Returns:
      the value of the `dwarfIntSize` record component